Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/PermissionOwner.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/PermissionOwner.cs	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/PermissionOwner.cs	(revision 845)
@@ -33,5 +33,5 @@
     public long PermissionOwnerId { get; set; }
     [DataMember]
-    public string name { get; set; }
+    public string Name { get; set; }
     
   }
Index: trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/User.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/User.cs	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Contracts/BusinessObjects/User.cs	(revision 845)
@@ -31,8 +31,4 @@
   public class User : PermissionOwner {
     [DataMember]
-    public long UserId { get; set; }
-    [DataMember]
-    public String Name { get; set; }
-    [DataMember]
     public String Password { get; set; }
   }
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientAdapter.cs	(revision 845)
@@ -29,5 +29,4 @@
 namespace HeuristicLab.Hive.Server.ADODataAccess {
   class ClientAdapter: IClientAdapter {
-    #region IClientAdapter Members
     private dsHiveServerTableAdapters.ClientTableAdapter adapter =
         new dsHiveServerTableAdapters.ClientTableAdapter();
@@ -35,4 +34,53 @@
     private ResourceAdapter resAdapter = 
       new ResourceAdapter();
+    
+    #region IClientAdapter Members
+    private ClientInfo Convert(dsHiveServer.ClientRow row) {
+      if(row != null) {
+        ClientInfo client = new ClientInfo();
+       
+        /*Parent - resource*/
+        Resource resource =
+          resAdapter.GetResourceById(row.ResourceId);
+        client.ResourceId = resource.ResourceId;
+        client.Name = resource.Name;
+
+        /*ClientInfo*/
+        client.ClientId = row.GUID;
+        client.CpuSpeedPerCore = row.CPUSpeed;
+        client.Memory = row.Memory;
+        client.Login = row.Login;
+        if (row.Status != null)
+          client.State = (State)Enum.Parse(typeof(State), row.Status, true);
+        client.NrOfCores = row.NumberOfCores;
+
+        //todo: config adapter (client.config)
+
+        return client;
+      }
+      else
+        return null;
+    }
+
+    private dsHiveServer.ClientRow Convert(ClientInfo client,
+      dsHiveServer.ClientRow row) {
+      if (client != null && row != null) {      
+        row.ResourceId = client.ResourceId;
+        row.GUID = client.ClientId;
+        row.CPUSpeed = client.CpuSpeedPerCore;
+        row.Memory = client.Memory;
+        row.Login = client.Login;
+        row.Status = client.State.ToString();
+        row.NumberOfCores = client.NrOfCores;
+
+        //todo: config adapter
+        /*if (client.Config != null)
+          row.ClientConfigId = client.Config.ClientConfigId;
+         else
+          row.ClientConfigId = null;*/
+      }
+
+      return row;
+    }
 
     public void UpdateClient(ClientInfo client) {
@@ -52,35 +100,8 @@
         }
 
-        row.ResourceId = client.ResourceId;
-        row.GUID = client.ClientId;
-        row.CPUSpeed = client.CpuSpeedPerCore;
-        //row.Memory = client.Memory;
-        /*if(client.Login != null)
-          row.Login = client.Login.ToString();*/
-        row.Status = client.State.ToString();
-        
-        //todo: config adapter
-        /*if (client.Config != null)
-          row.ClientConfigId = client.Config.ClientConfigId;*/
-        
-        row.NumberOfCores = client.NrOfCores;
+        Convert(client, row);
 
         adapter.Update(data);
       }
-    }
-
-    private ClientInfo Convert(dsHiveServer.ClientRow row) {
-      ClientInfo client = new ClientInfo();
-
-      client.ResourceId = row.ResourceId;
-      client.ClientId = row.GUID;
-      client.CpuSpeedPerCore = row.CPUSpeed;
-      //client.Memory = row.Memory;
-      //client.Login = row.Login;
-      //client.State =;
-      //client.Config
-      client.NrOfCores = row.NumberOfCores;
-
-      return client;
     }
 
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/HeuristicLab.Hive.Server.ADODataAccess.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/HeuristicLab.Hive.Server.ADODataAccess.csproj	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/HeuristicLab.Hive.Server.ADODataAccess.csproj	(revision 845)
@@ -59,4 +59,5 @@
     </Compile>
     <Compile Include="HiveServerADODataAccessPlugin.cs" />
+    <Compile Include="PermissionOwnerAdapter.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
     <Compile Include="Properties\Settings.Designer.cs">
@@ -66,4 +67,5 @@
     </Compile>
     <Compile Include="ResourceAdapter.cs" />
+    <Compile Include="UserAdapter.cs" />
   </ItemGroup>
   <ItemGroup>
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/PermissionOwnerAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/PermissionOwnerAdapter.cs	(revision 845)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/PermissionOwnerAdapter.cs	(revision 845)
@@ -0,0 +1,83 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+using HeuristicLab.Hive.Server.Core.InternalInterfaces.DataAccess;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess {
+  class PermissionOwnerAdapter: IPermissionOwner {
+    #region IPermissionOwner Members
+    private dsHiveServerTableAdapters.PermissionOwnerTableAdapter adapter =
+     new dsHiveServerTableAdapters.PermissionOwnerTableAdapter();
+
+    public void UpdatePermissionOwner(PermissionOwner permOwner) {
+      if (permOwner != null) {
+        dsHiveServer.PermissionOwnerDataTable data =
+          adapter.GetDataById(permOwner.PermissionOwnerId);
+
+        dsHiveServer.PermissionOwnerRow row;
+        if (data.Count == 0) {
+          row = data.NewPermissionOwnerRow();
+          data.AddPermissionOwnerRow(row);
+        } else {
+          row = data[0];
+        }
+
+        row.Name = permOwner.Name;
+
+        adapter.Update(data);
+
+        permOwner.PermissionOwnerId = row.PermissionOwnerId;
+      }
+    }
+
+    public PermissionOwner GetPermissionOwnerById(long resourceId) {
+      throw new NotImplementedException();
+    }
+
+    public ICollection<PermissionOwner> GetAllPermissionOwners() {
+      throw new NotImplementedException();
+    }
+
+    public bool DeletePermissionOwner(PermissionOwner permOwner) {
+      if (permOwner != null) {
+        dsHiveServer.PermissionOwnerDataTable data =
+           adapter.GetDataById(permOwner.PermissionOwnerId);
+
+        if (data.Count == 1) {
+          dsHiveServer.PermissionOwnerRow row = data[0];
+
+          row.Delete();
+          return adapter.Update(data) > 0;
+        }
+      }
+
+      return false;
+    }
+
+    #endregion
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ResourceAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ResourceAdapter.cs	(revision 844)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ResourceAdapter.cs	(revision 845)
@@ -33,4 +33,25 @@
       new dsHiveServerTableAdapters.ResourceTableAdapter();
 
+    private Resource Convert(dsHiveServer.ResourceRow row) {
+      if (row != null) {
+        Resource resource = new Resource();
+
+        resource.ResourceId = row.ResourceId;
+        resource.Name = row.Name;
+
+        return resource;
+      } else
+        return null;
+    }
+
+    private dsHiveServer.ResourceRow Convert(Resource resource,
+      dsHiveServer.ResourceRow row) {
+      if (resource != null && row != null) {
+        row.Name = resource.Name;
+      }
+
+      return row;
+    }
+
     public void UpdateResource(Resource resource) {
       if (resource != null) {
@@ -46,6 +67,5 @@
         }
 
-        //missing
-        row.Name = "test";
+        Convert(resource, row);
 
         adapter.Update(data);
@@ -55,24 +75,45 @@
     }
 
-    public ClientInfo GetResourceById(long resourceId) {
-      throw new NotImplementedException();
+    public Resource GetResourceById(long resourceId) {
+      dsHiveServer.ResourceDataTable data =
+          adapter.GetDataById(resourceId);
+      if (data.Count == 1) {
+        dsHiveServer.ResourceRow row =
+          data[0];
+        return Convert(row);
+      } else {
+        return null;
+      }
     }
 
     public ICollection<Resource> GetAllResources() {
-      throw new NotImplementedException();
+      ICollection<Resource> allResources =
+        new List<Resource>();
+
+      dsHiveServer.ResourceDataTable data =
+          adapter.GetData();
+
+      foreach (dsHiveServer.ResourceRow row in data) {
+        allResources.Add(Convert(row));
+      }
+
+      return allResources;
     }
 
     public bool DeleteResource(Resource resource) {
-      dsHiveServer.ResourceDataTable data =
-         adapter.GetDataById(resource.ResourceId);
+      if(resource != null) {
 
-      if (data.Count == 1) {
-        dsHiveServer.ResourceRow row = data[0];
+        dsHiveServer.ResourceDataTable data =
+           adapter.GetDataById(resource.ResourceId);
 
-        row.Delete();
-        return adapter.Update(data) > 0;
-      } else {
-        return false;
+        if (data.Count == 1) {
+          dsHiveServer.ResourceRow row = data[0];
+
+          row.Delete();
+          return adapter.Update(data) > 0;
+        } 
       }
+       
+      return false;
     }
 
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserAdapter.cs	(revision 845)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/UserAdapter.cs	(revision 845)
@@ -0,0 +1,86 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+using HeuristicLab.Hive.Server.Core.InternalInterfaces.DataAccess;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess {
+  class UserAdapter: IUserAdapter {
+    private dsHiveServerTableAdapters.HiveUserTableAdapter adapter =
+        new dsHiveServerTableAdapters.HiveUserTableAdapter();
+
+    private PermissionOwnerAdapter permOwnerAdapter =
+      new PermissionOwnerAdapter();
+
+    private User Convert(dsHiveServer.HiveUserRow row) {
+      if (row != null) {
+        User user = new User();
+
+        /*Parent - resource*/
+        PermissionOwner permOwner =
+          permOwnerAdapter.GetPermissionOwnerById(row.PermissionOwnerId);
+        user.PermissionOwnerId = permOwner.PermissionOwnerId;
+        user.Name = permOwner.Name;
+
+        /*User*/
+        user.Password = row.Password;
+
+        return user;
+      } else
+        return null;
+    }
+
+    private dsHiveServer.HiveUserRow Convert(User user,
+      dsHiveServer.HiveUserRow row) {
+      if (user != null && row != null) {
+        row.PermissionOwnerId = user.PermissionOwnerId;
+        row.Password = user.Password;
+      }
+
+      return row;
+    }
+
+    #region IUserAdapter Members
+
+    public void UpdateUser(User user) {
+      throw new NotImplementedException();
+    }
+
+    public ClientInfo GetUserById(long userId) {
+      throw new NotImplementedException();
+    }
+
+    public ICollection<User> GetAllUsers() {
+      throw new NotImplementedException();
+    }
+
+    public bool DeleteUser(User user) {
+      throw new NotImplementedException();
+    }
+
+    #endregion
+  }
+}
